﻿/*
 * goflow流程设计器插件
 * Author: Jimmy Cheung
 * Blog: http://www.cnblogs.com/eleven11/
*/
(function ($, undefined) {    

    //定义流程模板属性
    TemplateProperty = function () {
        if (typeof TemplateProperty.defaults == "undefined") {
            /*第一次定义对象时为GoFlow类定义静态属性*/
            TemplateProperty.defaults = {
                data: {
                    RecNo: 0,
                    TemplateCode: "",
                    TempateName: "",
                    SortOrder: 0,
                    FormNo: { RecNo: 0, Name: "" },
                    InstanceName: "",
                    Version: 1,
                    VerStatus: "设计",
                    DesignerNo: { RecNo: 0, Name: "" },
                    DesignTime: "",
                    PublisherNo: { RecNo: 0, Name: "" },
                    PublishTime: "",
                    Memo: ""
                }
            };
            /*第一次定义对象时定义实例共有方法*/
            var p = TemplateProperty.prototype;
            p.createTable = function () {
                this.$table = $("<table class='gf_prop_tb' cellpadding='0' cellspacing='0'></table>");
                this.$tbody = $("<tbody></tbody>");
                this.$table.append(this.$tbody);
                this.$propertyDiv.append(this.$table);
                //行0 - 基本属性（分组）
                this.$tbody.append(GoFlow.formatString(
                   "<tr style='display:table-row;background-color:rgb(234, 229, 229);height:0px;' group='TemplateBasic'>{0}</tr>",
                   "<td class='Expanded' group='TemplateBasic'></td><td style='width: 100%;height:0px;' colspan='3'>基本属性</td>"));
                //this.$trTemplateCode = $(GoFlow.formatString(
                //    "<tr group='TemplateBasic' property='TemplateCode'><td group='TemplateBasic'></td>{0}</tr>",
                //    "<td style='width:30%;'>流程编码</td><td style='width:70%;' colspan='2'><input type='text' maxlength='50'/></td>"));
                //this.$tbody.append(this.$trTemplateCode);
                //行1 - 流程编码
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateBasic' property='TemplateCode'><td/><td>流程编码</td>{0}</tr>",
                    "<td style='width:70%;' colspan='2'><input type='text' maxlength='50'/></td>"));
                //行2 - 流程名称
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateBasic' property='TemplateName'><td/><td>流程名称</td>{0}</tr>",
                    "<td style='width:70%;' colspan='2'><input type='text' maxlength='50'/></td>"));
                //行3 - 显示顺序
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateBasic' property='SortOrder'><td/><td>显示顺序</td>{0}</tr>",
                    "<td style='width:70%;' colspan='2'><input class='goflow-valid-int' type='text' maxlength='5'/></td>"));
                //行4 - 流程表单
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateBasic' property='InstanceName'><td/><td>流程表单</td><td style='width:70%;' colspan='2'>{0}</tr>",
                    "<input style='width:82%;'type='text' maxlength='50' readonly='readonly'/><input class='BizData' type='button' value='...'/></td>"));
                //行5 - 实例名称
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateBasic' property='InstanceName'><td/><td>实例名称</td><td style='width:70%;' colspan='2'>{0}</tr>",
                    "<input style='width:82%;'type='text' maxlength='50' readonly='readonly'/><input class='BizData' type='button' value='...'/></td>"));

                //行6 - 版本信息（分组）
                this.$tbody.append(GoFlow.formatString(
                   "<tr style='display:table-row;background-color:rgb(234, 229, 229);height:0px;' group='TemplateVersion'>{0}</tr>",
                   "<td class='Expanded' group='TemplateVersion'></td><td style='width: 100%;height:0px;' colspan='3'>版本信息</td>"));
                //行7 - 流程版本
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateVersion' property='Version'>{0}</tr>",
                    "<td/><td>流程版本</td><td style='width:70%;' colspan='2' readonly='true'><div></div></td>"));
                //行8 - 版本状态
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateVersion' property='VerStatus'>{0}</tr>",
                    "<td/><td>版本状态</td><td style='width:70%;' colspan='2' readonly='true'><div></div></td>"));
                //行9 - 修改人
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateVersion' property='DesignerNo'>{0}</tr>",
                    "<td/><td>修改人</td><td style='width:70%;' colspan='2' readonly='true'><div></div></td>"));
                //行10 - 修改时间
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateVersion' property='DesignTime'>{0}</tr>",
                    "<td/><td>修改时间</td><td style='width:70%;' colspan='2' readonly='true'><div></div></td>"));
                //行11 - 发布人
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateVersion' property='PublisherNo'>{0}</tr>",
                    "<td/><td>发布人</td><td style='width:70%;' colspan='2' readonly='true'><div></div></td>"));
                //行12 - 发布时间
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateVersion' property='PublishTime'>{0}</tr>",
                   "<td/><td>发布时间</td><td style='width:70%;' colspan='2' readonly='true'><div></div></td>"));

                //给控件赋值
                this.bindData();
                //绑定事件
                this.bindDelegate();
            };
            //把流程模板数据绑定到控件
            p.bindData = function () {
                var self = this;
                $.each(self.$opts.data, function (k, v) {
                    self.setValue(k, v);
                });
            };
            //绑定事件
            p.bindDelegate = function () {
                //展开/收缩属性组
                this.$tbody.delegate("td[group].Fold,td[group].Expanded", "click", { self: this }, function (e) {
                    var $templateProp = e.data.self;
                    var fold = $(e.target).hasClass("Fold");
                    $(e.target).toggleClass("Fold", !fold);
                    $(e.target).toggleClass("Expanded", fold);
                    var selector = GoFlow.formatString(
                        "[group='{0}'][property]",
                        $(e.target).attr("group"));
                    $templateProp.$tbody.children(selector).toggle();
                });
                //input绑定onchange事件 
                this.$tbody.delegate("td > input", "change", { self: this }, function (e) {
                    var $templateProp = e.data.self;
                    var key = $(e.target).parent().parent().attr("property");
                    var value = $(e.target).val();
                    $templateProp.setData(key, value);
                });
                //input绑定onkeydown事件 
                this.$tbody.delegate("td > input.goflow-valid-int", "keydown", function (e) {
                    return GoFlow.validInt(e);
                });
            };
            p.getData = function (key) { return this.$opts.data[key]; };
            p.setData = function (key, value) { this.$opts.data[key] = value; };
            p.getValue = function (key) {
                switch (key) {
                    case "TemplateCode":
                        break;
                    case "TemplateName":
                        break;
                    case "SortOrder":
                        break;
                    case "FormNo":
                        break;
                    case "InstanceName":
                        break;
                    case "Version":
                        break;
                    case "VerStatus":
                        break;
                    case "DesignerNo":
                        break;
                    case "DesignTime":
                        break;
                    case "PublisherNo":
                        break;
                    case "PublishTime":
                        break;
                    case "Memo":
                        break;
                    default:
                        break;
                };
            };
            p.setValue = function (key, value) {
                switch (key) {
                    case "TemplateCode":
                        this.$tbody.find("tr:eq(1) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "TempateName":
                        this.$tbody.find("tr:eq(2) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "SortOrder":
                        this.$tbody.find("tr:eq(3) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "FormNo":
                        this.$tbody.find("tr:eq(4) > td:eq(2)").children("input:first").val(value["Name"]);
                        break;
                    case "InstanceName":
                        this.$tbody.find("tr:eq(5) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "Version":
                        this.$tbody.find("tr:eq(7) > td:eq(2)").children("div:eq(0)").html(value);
                        break;
                    case "VerStatus":
                        this.$tbody.find("tr:eq(8) > td:eq(2)").children("div:eq(0)").html(value);
                        break;
                    case "DesignerNo":
                        this.$tbody.find("tr:eq(9) > td:eq(2)").children("div:eq(0)").html(value["Name"]);
                        break;
                    case "DesignTime":
                        this.$tbody.find("tr:eq(10) > td:eq(2)").children("div:eq(0)").html(value);
                        break;
                    case "PublisherNo":
                        this.$tbody.find("tr:eq(11) > td:eq(2)").children("div:eq(0)").html(value["Name"]);
                        break;
                    case "PublishTime":
                        this.$tbody.find("tr:eq(12) > td:eq(2)").children("div:eq(0)").html(value);
                        break;
                    case "Memo":
                        break;
                    default:
                        break;
                };
            };
        }
    };
    //初始化TemplateProperty对象
    TemplateProperty.prototype.init = function (pdiv, opts) {
        this.$propertyDiv = pdiv;
        this.$opts = opts;
        this.createTable();
    };

    //定义GoFlow类
    GoFlow = function () {
        if (typeof GoFlow.useSVG == "undefined") {
            /*第一次定义对象时为GoFlow类定义静态属性和静态方法*/
            /*静态属性*/
            //如果是IE6，IE7或者IE8则使用vml，其他浏览器使用svg。
            GoFlow.useSVG =
                (navigator.userAgent.indexOf("MSIE 8.0") > 0
                || navigator.userAgent.indexOf("MSIE 7.0") > 0
                || navigator.userAgent.indexOf("MSIE 6.0") > 0) ? false : true;
            //默认参数
            GoFlow.defaults = {
                width: 800,
                height: 500,
                workAreaWidth: 3758,
                workAreaHeight: 1836,
                haveHead: true,
                haveTool: true,
                useOperStack: true,
                toolOperBtn: {
                    "save": "保存",
                    "undo": "撤消",
                    "redo": "重做",
                    "reload": "刷新"
                },
                toolBoxBtn: {
                    "start": "开始结点",
                    "activity": "活动结点",
                    "condition": "条件结点",
                    "end": "结束结点"
                },
                onBtnNewClick: null, //新建流程图按钮
                onBtnOpenClick: null, //打开流程图按钮
                onBtnSaveClick: null, //保存流程图按钮
                onBtnReloadClick: null, //重载流程图按钮
                onItemAdd: null,
                onItemDel: null,
                onItemMove: null,
                onItemBlur: null,
                onItemFocus: null,
                onItemResize: null,
                onItemSetTitle: null,
                onLineMove: null,
                onLineSetType: null,
                onItemMark: null,
                templateOpts : {
                    data: {
                        RecNo: 0,
                        TemplateCode: "xlc1",
                        TemplateName: "新流程1",
                        SortOrder: 1,
                        FormNo: { RecNo: 0, Name: "" },
                        InstanceName: "",
                        Version: 1,
                        VerStatus: "设计",
                        DesignerNo: { RecNo: 0, Name: "" },
                        DesignTime: "",
                        PublisherNo: 0,
                        PublishTime: "",
                        Memo: ""
                    }
                }
            };

            /*静态方法（通用方法）*/
            //兼容各种浏览器的,获取鼠标真实位置
            GoFlow.mousePosition = function (ev) {
                if (!ev) ev = window.event;
                if (ev.pageX || ev.pageY) {
                    return { x: ev.pageX, y: ev.pageY };
                }
                return {
                    x: ev.clientX + document.documentElement.scrollLeft - document.body.clientLeft,
                    y: ev.clientY + document.documentElement.scrollTop - document.body.clientTop
                };
            };
            //获取一个DIV的绝对坐标的功能函数,即使是非绝对定位,一样能获取到
            GoFlow.getElCoordinate = function (dom) {
                var t = dom.offsetTop;
                var l = dom.offsetLeft;
                dom = dom.offsetParent;
                while (dom) {
                    t += dom.offsetTop;
                    l += dom.offsetLeft;
                    dom = dom.offsetParent;
                };
                return { top: t, left: l };
            };
            //限制只能输入整数
            GoFlow.validInt = function (e) {
                if (!e) e = window.event;
                if (!(e.keyCode == 46) && !(e.keyCode == 8) && !(e.keyCode == 37) && !(e.keyCode == 39)) {
                    if (!((e.keyCode >= 48 && e.keyCode <= 57) || (e.keyCode >= 96 && e.keyCode <= 105)))
                        return false;
                }
                return true;
            };
            //模拟实现C# String.format函数
            GoFlow.formatString = function () {
                var formatStr = arguments[0];
                if (typeof formatStr === 'string') {
                    var pattern;
                    for (var i = 1; i < arguments.length; i++) {
                        pattern = new RegExp('\\{' + (i - 1) + '\\}', 'g');
                        formatStr = formatStr.replace(pattern, arguments[i]);
                    }
                }
                else {
                    formatStr = '';
                }
                return formatStr;
            };
            /*静态方法(流程设计器相关方法)*/
            //获取svg箭头
            GoFlow.getSvgMarker = function (id, color) {
                var m = document.createElementNS("http://www.w3.org/2000/svg", "marker");
                m.setAttribute("id", id);
                m.setAttribute("viewBox", "0 0 6 6");
                m.setAttribute("refX", 5);
                m.setAttribute("refY", 3);
                m.setAttribute("markerUnits", "strokeWidth");
                m.setAttribute("markerWidth", 6);
                m.setAttribute("markerHeight", 6);
                m.setAttribute("orient", "auto");
                var path = document.createElementNS("http://www.w3.org/2000/svg", "path");
                path.setAttribute("d", "M 0 0 L 6 3 L 0 6 z");
                path.setAttribute("fill", color);
                path.setAttribute("stroke-width", 0);
                m.appendChild(path);
                return m;
            };

            /*第一次定义对象时定义实例共有方法*/
            var p = GoFlow.prototype;
            //设计器div:jQuery对象
            p.gfDiv = function () {
                return $(this).data('gfDiv');
            };

            /*1.初始化方法*/
            //1.1计算宽度
            p.calcWidth = function () {
                this.$opts.sWidth = !this.$editable && 0 || this.$opts.sWidth || 6;
                this.$opts.dWidth = !this.$editable && this.$opts.width || (this.$opts.width - this.$opts.sWidth) * 0.75;
                this.$opts.pWidth = !this.$editable && 0 || (this.$opts.width - this.$opts.dWidth - this.$opts.sWidth);
            };
            //1.2生成设计器、分隔条和属性
            p.createDiv = function () {
                this.calcWidth();                
                this.$designerDiv = $(GoFlow.formatString("<div class='gf_d' style='width:{0}px;height:{1}px;float:left;'></div>", this.$opts.dWidth, this.$opts.height));
                this.$gfDiv.append(this.$designerDiv);
                if (this.$editable) {
                    //创建分隔条
                    this.$sliderDiv = $(GoFlow.formatString("<div class='gf_s' style='width:{0}px;height:{1}px;float:left;'></div>", this.$opts.sWidth - 2, this.$opts.height));
                    this.$gfDiv.append(this.$sliderDiv);
                    //分隔条幽灵
                    this.$sliderGhostDiv = $(GoFlow.formatString("<div class='gf_s_g' style='width:{0}px;height:{1}px;float:left;'></div>", this.$opts.sWidth - 2, this.$opts.height));
                    this.$gfDiv.append(this.$sliderGhostDiv);

                    //创建属性
                    this.$propertyDiv = $(GoFlow.formatString("<div class='gf_p' style='width:{0}px;height:{1}px;float: left;'></div>", this.$opts.pWidth - 2, this.$opts.height));
                    this.$gfDiv.append(this.$propertyDiv);
                    //创建属性标题
                    this.$propertyHeadDiv = $(GoFlow.formatString("<div class='gf_p_head' style='width:{0}px;'></div>", this.$opts.pWidth - 2));
                    this.$propertyHeadDiv.append("<div class='gf_p_head_toggle'></div>");
                    this.$propertyHeadDiv.append(GoFlow.formatString("<div class='gf_p_head_inner'>{0}</div>","流程模板属性："));
                    this.$propertyDiv.append(this.$propertyHeadDiv);
                    //创建属性容器
                    this.$propertyBodyDiv = $(GoFlow.formatString("<div class='gf_p_body' style='height:{0}px;'></div>", this.$opts.height - 29));
                    this.$propertyDiv.append(this.$propertyBodyDiv);

                    //创建属性收缩起来后显示的div
                    this.$collapseDiv = $(GoFlow.formatString("<div class='gf_collapse' style='height:{0}px;display:none;'></div>", this.$opts.height));
                    this.$collapseDiv.append("<div class='gf_collapse_toggle'></div>");
                    this.$gfDiv.append(this.$collapseDiv);
                    
                    this.$sliderDiv.on("mousedown", { self: this }, function (e) {
                        var $gf = e.data.self;
                        $gf.$sliderMoving = true;
                        $gf.$gfDiv.css("cursor", "e-resize");
                        //$gf.$gfDiv[0].onselectstart = function (e) { return false; };
                    });
                    this.$gfDiv.on("mousemove", { self: this }, function (e) {
                        var $gf = e.data.self;
                        if ($gf.$sliderMoving) {
                            $gf.sliderGhostMoving(e);
                        }
                    });
                    this.$gfDiv.on("mouseup", { self: this }, function (e) {
                        var $gf = e.data.self;
                        if ($gf.$sliderMoving) {
                            $gf.$sliderMoving = false;
                            $gf.sliderHorizontalMove(e);
                            $gf.$gfDiv.css("cursor", "default");
                        }
                    });
                    this.$propertyHeadDiv.children(".gf_p_head_toggle").on("click", { self: this }, function (e) {
                        var $gf = e.data.self;
                        $gf.reinitWidth($gf.$opts.width - 26 - $gf.$opts.sWidth, 26);
                    });
                    this.$collapseDiv.children(".gf_collapse_toggle").on("click", { self: this }, function (e) {
                        var $gf = e.data.self;
                        var dWidth = ($gf.$opts.width - $gf.$opts.sWidth) * 0.75;
                        var pWidth = $gf.$opts.width - dWidth - $gf.$opts.sWidth;
                        $gf.reinitWidth(dWidth, pWidth);
                    });

                    //创建属性实例
                    this.createPropery();
                }
            };
            //1.3创建流程模板属性及各结点属性实例
            p.createPropery = function () {
                //创建流程模板属性实例
                this.$templateProp = new TemplateProperty();
                templateOpts = $.extend({}, TemplateProperty.defaults, this.$opts.templateOpts);
                this.$templateProp.init(this.$propertyBodyDiv, templateOpts);
            };
            //1.4生成顶部工具栏
            p.createHead = function () {
                var w = this.$opts.dWidth - 10;
                this.$title = this.$opts.wfTitle || "新流程1";
                this.$designerHeadDiv = $(GoFlow.formatString("<div class='gf_d_head'><label style='width:{0}px;' title='{1}'>{1}</label></div>", w, this.$title));
                this.$designerDiv.append(this.$designerHeadDiv);
            };
            //1.5生成左侧工具栏
            p.createTool = function () {
                var height = this.$opts.height - (this.$opts.haveHead ? 31 : 10);
                this.$designerDiv.append(GoFlow.formatString("<div class='gf_d_tool'{0}></div>", this.$opts.haveHead ? "" : " style='margin-top:3px'"));
                this.$designerToolDiv = $(GoFlow.formatString("<div class='gf_d_tool_div' style='height:{0}px'></div>", height));
                this.$designerDiv.children(".gf_d_tool").append(this.$designerToolDiv);
                //加入操作按钮
                this.$toolOper = $("<div class='gf_d_tool_div_opt'></div>");
                this.$designerToolDiv.append(this.$toolOper);
                if (this.$opts.toolOperBtn) {
                    var item = "";
                    var toolOperBtn = this.$opts.toolOperBtn;
                    $.each(toolOperBtn, function (k, v) {
                        item += GoFlow.formatString("<a href='javascript:void(0)' class='gf_d_opt_btn' title='{0}'><b class='ico_{1}'></b></a>", v, k);
                    });
                    item += "<span/>";
                    this.$toolOper.append(item);
                }
                /*以下是当工具栏按钮被点击时触发的事件*/
                this.onBtnNewClick = this.$opts.onBtnNewClick;  //新建流程图按钮
                this.onBtnOpenClick = this.$opts.onBtnOpenClick;//打开流程图按钮
                this.onBtnSaveClick = this.$opts.onBtnSaveClick;//保存流程图按钮
                this.onBtnReloadClick = this.$opts.onBtnReloadClick;  //重载流程图按钮
                //绑定各个操作按钮的点击事件
                if (this.$opts.toolOperBtn) {
                    this.$toolOper.on("click", { self: this }, function (e) {
                        if (!e) e = window.event;
                        var tar = e.target;
                        if (tar.tagName == "DIV" || tar.tagName == "SPAN") return;
                        else if (tar.tagName == "a") tar = tar.childNode[0];
                        var $gf = e.data.self;
                        //定义操作按钮的事件
                        switch ($(tar).attr("class")) {
                            case "ico_new": if ($gf.onBtnNewClick != null) $gf.onBtnNewClick(); break;
                            case "ico_open": if ($gf.onBtnOpenClick != null) $gf.onBtnOpenClick(); break;
                            case "ico_save": if ($gf.onBtnSaveClick != null) $gf.onBtnSaveClick(); break;
                            case "ico_undo": break;
                            case "ico_redo": break;
                            case "ico_reload": if ($gf.onBtnReloadClick != null) $gf.onBtnReloadClick(); break;
                        }
                    });
                }
                //加入结点按钮
                this.$toolBox = $("<div class='gf_d_tool_div_box'></div>");
                this.$designerToolDiv.append(this.$toolBox);
                this.$toolBox.append("<span/><a href='javascript:void(0)' class='gf_d_box_btndown' id='" + this.$id + "_btn_cursor' title='指针'><b class='ico_cursor'/></a>");//鼠标指针
                this.$toolBox.append("<a href='javascript:void(0)' class='gf_d_box_btn' id='" + this.$id + "_btn_line' title='连线'><b class='ico_line'/></a>");   //连线
                if (this.$opts.toolBoxBtn) {
                    var item = "<span/>";
                    var $id = this.$id;
                    var toolBoxBtn = this.$opts.toolBoxBtn;
                    $.each(toolBoxBtn, function (k, v) {
                        item += GoFlow.formatString("<a href='javascript:void(0)' id='{0}_btn_{1}' class='gf_d_box_btn'><b class='ico_{1}' title='{2}'/></a>", $id, k, v);
                    });
                    item += "<span/>";
                    this.$toolBox.append(item);
                }
                //绑定各个组件按钮的点击事件
                this.$toolBox.on("click", { self: this }, function (e) {
                    if (!e) e = window.event;
                    var tar;
                    switch (e.target.tagName) {
                        case "DIV": return false;
                        case "SPAN": return false;
                        case "A": tar = e.target; break;
                        case "B": tar = e.target.parentNode;
                    };
                    var type = $(tar).attr("id").split("btn_")[1];
                    e.data.self.switchToolBtn(type);
                    return false;
                });
            };
            //1.6生成工作区域
            p.createWorkArea = function () {
                var w = this.$opts.dWidth - (this.$opts.haveTool ? 39 : 8);
                var h = this.$opts.height - (this.$opts.haveHead ? 29 : 8);
                this.$designerDiv.append(GoFlow.formatString(
                    "<div class='gf_d_work' style='width:{0}px;height:{1}px;{2}'></div>", w, h, this.$opts.haveHead ? "" : "margin-top:3px"));
                this.$workArea = $(GoFlow.formatString(
                    "<div class='gf_d_work_inner' style='width:{0}px;height:{1}px'></div>", this.$opts.workAreaWidth, this.$opts.workAreaHeight))
                    .attr({ "unselectable": "on", "onselectstart": 'return false', "onselect": 'document.selection.empty()' });
                this.$designerDiv.children(".gf_d_work").append(this.$workArea);
            };            
            //1.7创建化画板（用于画线）
            p.createDrawBoard = function () {
                if (GoFlow.useSVG) {
                    this.$drawBoard = document.createElementNS("http://www.w3.org/2000/svg", "svg");
                    this.$workArea.prepend(this.$drawBoard);
                    var defs = document.createElementNS("http://www.w3.org/2000/svg", "defs");
                    this.$drawBoard.appendChild(defs);
                    defs.appendChild(GoFlow.getSvgMarker("arrow1", "#15428B"));
                    defs.appendChild(GoFlow.getSvgMarker("arrow2", "#ff3300"));
                    defs.appendChild(GoFlow.getSvgMarker("arrow3", "#ff3300"));
                }
                else {
                    this.$drawBoard = document.createElement("v:group");
                    this.$drawBoard.coordsize = this.$opts.workAreaWidth + "," + this.$opts.workAreaHeight;
                    this.$workArea.prepend(GoFlow.formatString(
                        "<div class='gf_d_work_vml' style='position:relative;width:{0}px;height:{1}px'></div>", this.$opts.workAreaWidth, this.$opts.workAreaHeight));
                    this.$workArea.children("div")[0].insertBefore(this.$drawBoard, null);
                }
                this.$drawBoard.id = "draw_" + this.$id;
                this.$drawBoard.style.width = this.$opts.workAreaWidth + "px";
                this.$drawBoard.style.height = this.$opts.workAreaHeight + "px";
            };
            //1.8初始化工作区事件
            p.bindWorkAreaDelegate = function () {
                this.$workArea.on("click", { self: this }, function (e) {
                    if (!e) e = window.event;
                    var $gf = e.data.self;
                    if (!$gf.$editable) return;
                    if ($gf.$curType == "cursor") { //取消选中
                        var t = $(e.target);
                        var n = t.prop("tagName");
                        if (n == "svg" || (n == "DIV" && t.prop("class").indexOf("gf_d_work") > -1)) {
                            $gf.blurItem();  //取消选中
                        }
                    }
                    else if ($gf.$curType != "line") { //添加结点
                        //var id = "item_" + $gf.$max;
                        var idx = $gf.getNodeIdx($gf.$curType);
                        var id = $gf.$curType + "_" + idx;
                        var title = ($gf.$curType == "start" && "开始")
                            || ($gf.$curType == "end" && "结束")
                            || ($gf.$curType == "activity" && "活动" + idx)
                            || ($gf.$curType == "condition" && "条件" + idx);
                        var ev = GoFlow.mousePosition(e), t = GoFlow.getElCoordinate(this);
                        var X = ev.x - t.left + this.parentNode.scrollLeft;
                        var Y = ev.y - t.top + this.parentNode.scrollTop;
                        $gf.addNode(id, { title: title, left: X, top: Y, type: $gf.$curType });
                        $gf.$max++;
                    }
                });                
            };
            //1.9初始化结点事件
            p.bindNodeDelegate = function () {
                //绑定点击事件
                this.$workArea.delegate(".gf_d_item", "click", { self: this }, function (e) {
                    e.data.self.focusItem(this.id, true);
                    $(this).removeClass("item_line_enter");
                    $(this).removeClass("item_cursor_enter");
                });
                if (!this.$editable) return;
                //绑定鼠标覆盖/移出事件
                this.$workArea.delegate(".gf_d_item", "mouseenter", { self: this }, function (e) {
                    if (e.data.self.$curType == "cursor") {
                        $(this).addClass("item_cursor_enter");
                    }
                    else if (e.data.self.$curType == "line") {
                        $(this).addClass("item_line_enter");
                    }
                });
                this.$workArea.delegate(".gf_d_item", "mouseleave", { self: this }, function (e) {
                    var $gf = e.data.self;
                    if ($gf.$curType == "cursor") {
                        $gf.$nodeMoving = false;
                        $(this).removeClass("item_cursor_enter");
                    }
                    else if ($gf.$curType == "line") {
                        $(this).removeClass("item_line_enter");
                    }
                });
                this.$workArea.delegate(".gf_d_item", "mousemove", { self: this }, function (e) {
                    var $gf = e.data.self;
                    if ($gf.$curType == "cursor") {
                        if ($gf.$nodeMoving) {//确定节点移动初始点及绑定移动事件
                            if (!e) e = window.event;
                            var id = $(this).attr("id");
                            //$gf.focusItem(id, true);
                            var hack = (navigator.userAgent.indexOf("8.0") != -1 ? 0 : 1);
                            var ev = GoFlow.mousePosition(e), t = GoFlow.getElCoordinate($gf.$workArea[0]);
                            $gf.$ghost.css({
                                cursor: "move",
                                display: "block",
                                width: $gf.$nodeData[id].width - 2 + "px", height: $gf.$nodeData[id].height - 2 + "px",
                                top: $gf.$nodeData[id].top + t.top - $gf.$workArea[0].parentNode.scrollTop + hack + "px",
                                left: $gf.$nodeData[id].left + t.left - $gf.$workArea[0].parentNode.scrollLeft + hack + "px"
                            });
                            $(this).children("table").clone().prependTo($gf.$ghost);
                            var X = ev.x - t.left + $gf.$workArea[0].parentNode.scrollLeft;
                            var Y = ev.y - t.top + $gf.$workArea[0].parentNode.scrollTop;
                            var vX = X - $gf.$nodeData[id].left, vY = Y - $gf.$nodeData[id].top;
                            var isMove = false;
                            document.onmousemove = function (e) {
                                if (!e) e = window.event;
                                var ev = GoFlow.mousePosition(e);
                                X = ev.x - vX; Y = ev.y - vY;
                                if (X < t.left - $gf.$workArea[0].parentNode.scrollLeft)
                                    X = t.left - $gf.$workArea[0].parentNode.scrollLeft;
                                else if (X + $gf.$workArea[0].parentNode.scrollLeft + $gf.$nodeData[id].width > t.left + $gf.$workArea.width())
                                    X = t.left + $gf.$workArea.width() - $gf.$workArea[0].parentNode.scrollLeft - $gf.$nodeData[id].width;
                                if (Y < t.top - $gf.$workArea[0].parentNode.scrollTop)
                                    Y = t.top - $gf.$workArea[0].parentNode.scrollTop;
                                else if (Y + $gf.$workArea[0].parentNode.scrollTop + $gf.$nodeData[id].height > t.top + $gf.$workArea.height())
                                    Y = t.top + $gf.$workArea.height() - $gf.$workArea[0].parentNode.scrollTop - $gf.$nodeData[id].height;
                                $gf.$ghost.css({ left: X + hack + "px", top: Y + hack + "px" });
                                isMove = true;
                            }
                            document.onmouseup = function (e) {
                                if (isMove) {
                                    $gf.moveNode(id, X + $gf.$workArea[0].parentNode.scrollLeft - t.left,
                                                     Y + $gf.$workArea[0].parentNode.scrollTop - t.top);
                                }
                                $gf.$nodeMoving = false; 
                                $gf.focusItem(id, true);
                                $gf.$ghost.empty().hide();
                                document.onmousemove = null;
                                document.onmouseup = null;
                            }
                        }
                        else if (!$(this).hasClass("item_cursor_enter")) {
                            $(this).addClass("item_cursor_enter");
                        }
                    }
                });
                //绑定节点鼠标按下事件
                this.$workArea.delegate(".gf_d_item", "mousedown", { self: this }, function (e) {
                    var $gf = e.data.self;
                    if ($gf.$curType == "cursor") {
                        $gf.$nodeMoving = true;
                    }
                    else {
                        $gf.$nodeMoving = true;
                        $gf.switchToolBtn("cursor");
                        //$(this).removeClass("item_line_enter");
                        //$(this).addClass("item_cursor_enter");
                    }
                });
                //绑定标题双击编辑事件（串签、并签和条件）        
                this.$workArea.delegate("td.item_title", "dblclick", { self: this }, function (e) {
                    var $gf = e.data.self;
                    var oldTxt = this.innerHTML;
                    var id = $(this).parents(".gf_d_item").attr("id");
                    var t = GoFlow.getElCoordinate($gf.$workArea[0]);
                    $gf.$textArea.val(oldTxt).css({
                        display: "block", width: $(this).width() - 2, height: $(this).height() - 2,
                        left: t.left + 24 + $gf.$nodeData[id].left - $gf.$workArea[0].parentNode.scrollLeft,
                        top: t.top + 2 + $gf.$nodeData[id].top - $gf.$workArea[0].parentNode.scrollTop
                    }).data("id", $gf.$focusId).focus();
                    $gf.$workArea.parent().one("mousedown", function (e) {
                        $gf.setItemTitle($gf.$textArea.data("id"), $gf.$textArea.val(), $gf.$nodeData[id].type);
                        $gf.$textArea.val("").removeData("id").hide();
                    });
                });
                //绑定结点的删除功能
                this.$workArea.delegate(".rs_close", "click", { self: this }, function (e) {
                    if (!e) e = window.event;
                    e.data.self.delNode(e.data.self.$focusId);
                    return false;
                });
                //绑定结点的RESIZE功能
                this.$workArea.delegate(".gf_d_item > div > div[class!=rs_close]", "mousedown", { self: this }, function (e) {
                    if (!e) e = window.event;
                    var cursor = $(this).css("cursor");
                    if (cursor == "pointer") { return; }
                    var $gf = e.data.self;
                    var id = $gf.$focusId;
                    $gf.switchToolBtn("cursor");
                    e.cancelBubble = true;
                    e.stopPropagation();
                    var hack = 1;
                    if (navigator.userAgent.indexOf("8.0") != -1) hack = 0;
                    var ev = GoFlow.mousePosition(e), t = GoFlow.getElCoordinate($gf.$workArea[0]);
                    $gf.$ghost.css({
                        display: "block",
                        width: $gf.$nodeData[id].width - 2 + "px", height: $gf.$nodeData[id].height - 2 + "px",
                        top: $gf.$nodeData[id].top + t.top - $gf.$workArea[0].parentNode.scrollTop + hack + "px",
                        left: $gf.$nodeData[id].left + t.left - $gf.$workArea[0].parentNode.scrollLeft + hack + "px", cursor: cursor
                    });
                    var X, Y;
                    X = ev.x - t.left + $gf.$workArea[0].parentNode.scrollLeft;
                    Y = ev.y - t.top + $gf.$workArea[0].parentNode.scrollTop;
                    var vX = ($gf.$nodeData[id].left + $gf.$nodeData[id].width) - X;
                    var vY = ($gf.$nodeData[id].top + $gf.$nodeData[id].height) - Y;
                    var isMove = false;
                    $gf.$ghost.css("cursor", cursor);
                    document.onmousemove = function (e) {
                        if (!e) e = window.event;
                        var ev = GoFlow.mousePosition(e);
                        X = ev.x - t.left + $gf.$workArea[0].parentNode.scrollLeft - $gf.$nodeData[id].left + vX;
                        Y = ev.y - t.top + $gf.$workArea[0].parentNode.scrollTop - $gf.$nodeData[id].top + vY;
                        if (X < 86) X = 86;
                        if (Y < 24) Y = 24;
                        isMove = true;
                        switch (cursor) {
                            case "nw-resize": $gf.$ghost.css({ width: X - 2 + "px", height: Y - 2 + "px" }); break;
                            case "w-resize": $gf.$ghost.css({ width: X - 2 + "px" }); break;
                            case "n-resize": $gf.$ghost.css({ height: Y - 2 + "px" }); break;
                        }
                    }
                    document.onmouseup = function (e) {
                        $gf.$ghost.hide();
                        if (!isMove) return;
                        if (!e) e = window.event;
                        $gf.resizeNode(id, $gf.$ghost.outerWidth(), $gf.$ghost.outerHeight());
                        document.onmousemove = null;
                        document.onmouseup = null;
                    }
                });
            };
            //1.10绑定结点/线的一些操作事件
            p.bindItemOperEvent = function (opts) {
                /*下面绑定结点/线的一些操作事件,这些事件可直接通过this访问对象本身*/
                /*当操作某个单元（结点/线）被添加时，触发的方法，返回FALSE可阻止添加事件的发生
                //格式function(id,type,data)：id是单元的唯一标识ID,type是单元的种类,有"node","line"两种取值,data即addNode或addLine方法的第二个传参data.*/
                this.onItemAdd = this.$opts.onItemAdd;
                //当操作某个单元（结点/线/分组块）被删除时，触发的方法，返回FALSE可阻止删除事件的发生
                //格式function(id，type)：id是单元的唯一标识ID,type是单元的种类,有"node","line","area"三种取值
                this.onItemDel = this.$opts.onItemDel;
                //当操作某个单元（结点/分组块）被移动时，触发的方法，返回FALSE可阻止移动事件的发生
                //格式function(id，type,left,top)：id是单元的唯一标识ID,type是单元的种类,有"node","area"两种取值，线line不支持移动,left是新的左边距坐标，top是新的顶边距坐标
                this.onItemMove = this.$opts.onItemMove;
                //当操作某个单元（结点/线/分组块）被重命名时，触发的方法，返回FALSE可阻止重命名事件的发生
                //格式function(id,title,type)：id是单元的唯一标识ID,type是单元的种类,有"node","line","area"三种取值,title是新的标题
                this.onItemSetTitle = this.$opts.onItemSetTitle;
                //当操作某个单元（结点/线）被由不选中变成选中时，触发的方法，返回FALSE可阻止选中事件的发生
                //格式function(id,type)：id是单元的唯一标识ID,type是单元的种类,有"node","line"两种取值,"area"不支持被选中
                this.onItemFocus = this.$opts.onItemFocus;
                //当操作某个单元（结点/线）被由选中变成不选中时，触发的方法，返回FALSE可阻止取消选中事件的发生
                //格式function(id，type)：id是单元的唯一标识ID,type是单元的种类,有"node","line"两种取值,"area"不支持被取消选中
                this.onItemBlur = this.$opts.onItemBlur;
                //当操作某个单元（结点/分组块）被重定义大小或造型时，触发的方法，返回FALSE可阻止重定大小/造型事件的发生
                //格式function(id，type,width,height)：id是单元的唯一标识ID,type是单元的种类,有"node","line","area"三种取值;width是新的宽度,height是新的高度
                this.onItemResize = this.$opts.onItemResize;
                //当移动某条折线中段的位置，触发的方法，返回FALSE可阻止重定大小/造型事件的发生
                //格式function(id，M)：id是单元的唯一标识ID,M是中段的新X(或Y)的坐标
                this.onLineMove = this.$opts.onLineMove;
                //当变换某条连接线的类型，触发的方法，返回FALSE可阻止重定大小/造型事件的发生
                //格式function(id，type)：id是单元的唯一标识ID,type是连接线的新类型,"I":直线,"Z":中段可左右移动的折线,"N":中段可上下移动的折线
                this.onLineSetType = this.$opts.onLineSetType;
                //当用重色标注某个结点/转换线时触发的方法，返回FALSE可阻止重定大小/造型事件的发生
                //格式function(id，type，mark)：id是单元的唯一标识ID,type是单元类型（"node"结点,"line"转换线），mark为布尔值,表示是要标注TRUE还是取消标注FALSE
                this.onItemMark = this.$opts.onItemMark;
            };
            //1.11创建结点遮罩层、标题文本框、折线移动框
            p.createGhost = function () {
                //结点进行移动或者RESIZE时用来显示的遮罩层
                this.$ghost = $("<div class='rs_ghost'></div>").attr({ "unselectable": "on", "onselectstart": 'return false', "onselect": 'document.selection.empty()' });
                this.$designerDiv.append(this.$ghost);
                //标题录入文本框
                this.$textArea = $("<textarea></textarea>");
                this.$designerDiv.append(this.$textArea);                
            };

            //切换左边工具栏按钮,传参type表示切换成哪种类型的按钮
            p.switchToolBtn = function (type) {
                this.$toolBox.children("#" + this.$id + "_btn_" + this.$curType).attr("class", "gf_d_box_btn");
                this.$curType = type;
                this.$toolBox.children("#" + this.$id + "_btn_" + this.$curType).attr("class", "gf_d_box_btndown");
                if (this.$textArea.css("display") == "none") this.$textArea.removeData("id").val("").hide();
                if (this.$curType == "cursor") {
                    this.$workArea.css("cursor", "default");
                }
                else if (this.$curType == "line") {
                    this.$workArea.css("cursor", "crosshair");
                }
                else {
                    this.$workArea.css("cursor", "help");
                }
            };
            //设置流程图的名称
            p.setGoFlowTitle = function (text) {
                this.$title = text;
                if (this.$designerHeadDiv) this.$designerHeadDiv.children("label").attr("title", text).text(text);
            };
            //设置结点的文字信息
            p.setItemTitle = function (id, title, type) {
                var oldTitle;
                if (type != "line") {//如果是结点
                    if (!this.$nodeData[id]) return;
                    if (this.$nodeData[id].title == title) return;
                    if (this.onItemSetTitle != null && !this.onItemSetTitle(id, title, type)) return;
                    oldTitle = this.$nodeData[id].title;
                    this.$nodeData[id].title = title;
                    if (this.$nodeData[id].type == "start"
                        || this.$nodeData[id].type == "end") {
                        this.$nodeDom[id].children(".span").text(title);
                    }
                    else {
                        this.$nodeDom[id].find("td:eq(1)").text(title);
                        var hack = 0;
                        if (navigator.userAgent.indexOf("8.0") != -1) hack = 2;
                        var width = this.$nodeDom[id].outerWidth();
                        var height = this.$nodeDom[id].outerHeight();
                        this.$nodeDom[id].children("table").css({ width: width - 2 + "px", height: height - 2 + "px" });
                        this.$nodeData[id].width = width;
                        this.$nodeData[id].height = height;
                    }
                }
            };
            //取消所有结点被选定的状态
            p.blurItem = function () {
                if (this.$focusId != "") {
                    var jq = $("#" + this.$focusId);
                    if (jq.prop("tagName") == "DIV") {
                        if (this.onItemBlur != null && !this.onItemBlur(id, "node")) return false;
                        jq.removeClass("item_focus").children("div:eq(0)").css("display", "none");
                    }
                }
                this.$focusId = "";
                return true;
            };
            //选定某个结点 bool:TRUE决定了要触发选中事件，FALSE则不触发选中事件，多用在程序内部调用。
            p.focusItem = function (id, bool) {
                var $item = $("#" + id);
                if ($item.length == 0) return;
                if (!this.blurItem()) return;//先执行"取消选中",如果返回FLASE,则也会阻止选定事件继续进行.
                if ($item.prop("tagName") == "DIV") {
                    if (bool && this.onItemFocus != null && !this.onItemFocus(id, "node")) return;
                    $item.addClass("item_focus");
                    if (this.$editable) $item.children("div:eq(0)").css("display", "block");
                    this.$workArea.append($item);
                }
                this.$focusId = id;
                this.switchToolBtn("cursor");
            };
            //获取结点的详细信息
            p.getItemInfo = function (id, type) {
                switch (type) {
                    case "node": return this.$nodeData[id] || null;
                    default: return null;
                }
            };

            /*结点操作*/
            //增加结点时获取结点ID的索引
            p.getNodeIdx = function (type) {
                var idx = 1, ids = [];
                $.each(this.$nodeData, function (ii, item) {
                    if (item.type == type) ids.push(item.id);
                });
                if (ids.length > 0) {
                    ids.sort();
                    for (var i = 0; i < ids.length; i++) {
                        idx = i + 1;
                        if (ids[i].split("_")[1] != idx) break;
                    }
                    if (idx == ids.length) idx++;
                }
                return idx;
            };
            //增加一个流程结点,传参为一个JSON,有id,title,top,left,width,height,type(结点类型)等属性
            p.addNode = function (id, data) {
                if (this.onItemAdd != null && !this.onItemAdd(id, "node", data)) return;
                data.id = id;
                var mark = data.mark ? " item_mark" : "";
                if (data.type == "start" || data.type == "end") {
                    data.width = 24; data.height = 24;
                    this.$nodeDom[id] = $("<div class='gf_d_item item_round" + mark + "' id='" + id + "' style='left:" + data.left + "px;top:" + data.top + "px'><table cellspacing='0'><tr><td class='ico'><b class='ico_" + data.type + "'></b></td></tr></table><div  style='display:none'><div class='rs_close'></div></div><div class='item_title'>" + data.title + "</div></div>");
                }
                else if (data.type == "condition") {
                    data.width = data.width ? data.width : 102;
                    data.height = data.height ? data.height : 76;
                    if (data.top < 0) data.top = 0;
                    if (data.left < 0) data.left = 0;
                    this.$nodeDom[id] = $("<div class='gf_d_item item_condition" + mark + "' id='" + id + "' style='left:" + data.left + "px;top:" + data.top + "px'><table cellspacing='1' style='width:" + (data.width - 2) + "px;height:" + (data.height - 2) + "px;'><tr><td style='width:3px;'></td><td class='item_ico'><b class='ico_" + data.type + "'></b></td><td class='item_title'>" + data.title + "</td><td class='item_ico'>&nbsp;</td></tr></table><div style='display:none'><div class='rs_close'></div></div></div>");
                }
                else {
                    data.width = data.width ? data.width : 122;
                    data.height = data.height ? data.height : 52;
                    if (data.top < 0) data.top = 0;
                    if (data.left < 0) data.left = 0;
                    this.$nodeDom[id] = $("<div class='gf_d_item" + mark + "' id='" + id + "' style='left:" + data.left + "px;top:" + data.top + "px'><table cellspacing='1' style='width:" + (data.width - 2) + "px;height:" + (data.height - 2) + "px;'><tr><td class='item_ico'><b class='ico_" + data.type + "'></b></td><td class='item_title'>" + data.title + "</td></tr></table><div style='display:none'><div class='rs_bottom'></div><div class='rs_right'></div><div class='rs_rb'></div><div class='rs_close'></div></div></div>");
                }
                var ua = navigator.userAgent.toLowerCase();
                if (ua.indexOf('msie') != -1 && ua.indexOf('8.0') != -1) {
                    this.$nodeDom[id].css("filter", "progid:DXImageTransform.Microsoft.Shadow(color=#94AAC2,direction=135,strength=2)");
                }
                this.$workArea.append(this.$nodeDom[id]);
                this.$nodeData[id] = data;
                this.$nodeCount++;
            };            
            //删除结点
            p.delNode = function (id) {
                if (!this.$nodeData[id]) return;
                if (this.onItemDel != null && !this.onItemDel(id, "node")) return;
                delete this.$nodeData[id];
                this.$nodeDom[id].remove();
                delete this.$nodeDom[id];
                this.$nodeCount--;
                if (this.$focusId == id) this.$focusId = "";
            };
            //移动结点到一个新的位置
            p.moveNode = function (id, left, top) {
                if (!this.$nodeData[id]) return;
                if (this.onItemMove != null && !this.onItemMove(id, "node", left, top)) return;
                if (left < 0) left = 0;
                if (top < 0) top = 0;
                $("#" + id).css({ left: left + "px", top: top + "px" });
                this.$nodeData[id].left = left;
                this.$nodeData[id].top = top;
            };
            //设置结点的尺寸,仅支持非开始/结束结点
            p.resizeNode = function (id, width, height) {
                if (!this.$nodeData[id]) return;
                if (this.onItemResize != null && !this.onItemResize(id, "node", width, height)) return;
                if (this.$nodeData[id].type == "start" || this.$nodeData[id].type == "end") return;
                var hack = 0;
                if (navigator.userAgent.indexOf("8.0") != -1) hack = 2;
                this.$nodeDom[id].children("table").css({ width: width - 2 + "px", height: height - 2 + "px" });
                width = this.$nodeDom[id].outerWidth() - hack;
                height = this.$nodeDom[id].outerHeight() - hack;
                this.$nodeDom[id].children("table").css({ width: width - 2 + "px", height: height - 2 + "px" });
                this.$nodeData[id].width = width;
                this.$nodeData[id].height = height;
            };

            //分隔条幽灵左右拖动(mousemove)
            p.sliderGhostMoving = function (e) {
                var dWidth = GoFlow.mousePosition(e).x - 2;
                var pWidth = this.$opts.width - dWidth - this.$opts.sWidth;
                if (pWidth > 800 || dWidth < 100
                    || dWidth > this.$opts.width - this.$opts.sWidth) return;
                this.$sliderGhostDiv.css({ left: dWidth, display: "block" });
            };
            //完成分隔条左右拖动(mouseup)
            p.sliderHorizontalMove = function (e) {
                var dWidth = GoFlow.getElCoordinate(this.$sliderGhostDiv[0]).left - 2;
                var pWidth = this.$opts.width - dWidth - this.$opts.sWidth;
                if (pWidth < 27) {
                    pWidth = 26;
                    dWidth = this.$opts.width - pWidth - this.$opts.sWidth;
                }
                this.reinitWidth(dWidth, pWidth);
                this.$sliderGhostDiv.css("display", "none");
            };
            //设置设计器div和属性div的宽度
            p.reinitWidth = function (dWidth, pWidth) {
                if (pWidth <= 26) {
                    this.$collapseDiv.css("display", "block");
                    this.$propertyDiv.css("display", "none");
                }
                else {
                    this.$propertyDiv.css("display", "block");
                    this.$collapseDiv.css("display", "none");
                }
                this.$opts.dWidth = dWidth;
                this.$opts.pWidth = pWidth;
                this.$designerDiv.css("width", this.$opts.dWidth + "px");
                this.$propertyDiv.css("width", this.$opts.pWidth - 2 + "px");
                this.$propertyHeadDiv.css("width", this.$opts.pWidth - 2 + "px");
                this.$designerHeadDiv.children("label").css("width", this.$opts.dWidth - 10 + "px");
                this.$workArea.parent().css("width", this.$opts.dWidth - 39 + "px");
            };
            //重构整个流程图设计器的宽高
            p.reinitSize = function (width, height) {
                var w = (width || 800) - 2;
                var h = (height || 500) - 2;
                this.$opts.width = w;
                this.$opts.height = h;
                this.calcWidth();
                this.$designerDiv.css({ height: h + "px", width: this.$opts.dWidth + "px" });
                if (this.$editable) {
                    this.$sliderDiv.css("height", h + "px");
                    this.$sliderGhostDiv.css("height", h + "px");
                    this.$propertyDiv.css({ height: h + "px", width: this.$opts.pWidth - 2 + "px" });
                    this.$propertyHeadDiv.css("width", this.$opts.pWidth - 2 + "px");
                    this.$propertyBodyDiv.css("height", h - 29 + "px");
                    this.$collapseDiv.css("height", h + "px");
                }
                var headHeight = 0, hack = 10;
                if (this.$designerHeadDiv != null) {
                    headHeight = 24;
                    hack = 7;
                }
                if (this.$designerToolDiv != null) {
                    this.$designerToolDiv.css({ height: h - headHeight - hack + "px" });
                }
                if (this.$designerHeadDiv != null) {
                    this.$designerHeadDiv.children("label").css({ width: this.$opts.dWidth - 10 + "px" });
                }
                w = this.$opts.dWidth - 39;
                h = h - headHeight - (this.$designerHeadDiv != null ? 5 : 8);
                this.$workArea.parent().css({ height: h + "px", width: w + "px" });
            };
        }
    };    
    //初始化GoFlow对象（gfDiv:jQuery对象；opts:参数）
    GoFlow.prototype.init = function (gfDiv, opts) {
        //保存设计器div:jQuery对象
        $(this).data('gfDiv', gfDiv);
        //定义goflow的属性
        this.$id = gfDiv.attr("id");
        this.$opts = opts;
        this.$gfDiv = gfDiv;
        this.$designerDiv = null; //设计器div
        this.$sliderDiv = null; //分隔条div
        this.$sliderGhostDiv = null; //分隔条移动div
        this.$propertyDiv = null; //属性div
        this.$collapseDiv = null; //属性收缩起来后显示的div
        this.$designerHeadDiv = null; //设计器顶部标签
        this.$propertyHeadDiv = null; //属性顶部标签
        this.$propertyBodyDiv = null; //属性容器
        this.$designerToolDiv = null; //左侧工具栏对象
        this.$toolOper = null; //左侧工具栏（操作）对象
        this.$toolBox = null; //左侧工具栏（工具箱）对象
        this.$workArea = null; //工作区域（结点、画板的容器）
        this.$drawBoard = null; //画板（矢量线条的容器）
        this.$templateProp = null; //流程模板属性
        this.$title = null; //流程的名称
        this.$curType = "cursor"; //当前要绘制的对象类型（默认为指针）
        this.$cursor = "default"; //鼠标指针在工作区内的样式
        this.$nodeCount = 0;
        this.$nodeData = {};
        this.$nodeDom = {};
        this.$max = this.$opts.itemCount || 1;//计算默认ID值的起始序号
        this.$focusId = "";//当前被选定的结点/转换线ID,如果没选中或者工作区被清空,则为""
        this.$editable = this.$opts.haveTool ? true : false;//工作区是否可编辑（只有具有工具栏时可编辑）
        this.$nodeMoving = false;//是否正在进行结点移动。
        this.$sliderMoving = false;//是否正在进行左右分隔移动。
        
        //设计器宽高
        this.$opts.width -= 2;
        this.$opts.height -= 2;
        //添样式
        this.$gfDiv.addClass("gf");
        //生成布局
        this.createDiv();
        //生成顶部工具栏
        if (this.$opts.haveHead) {
            this.createHead();
        }
        //生成左侧工具栏
        if (this.$opts.haveTool) {
            this.createTool();
        }
        //生成工作区域
        this.createWorkArea();
        //初始化画板
        this.createDrawBoard();
        //如果是可编辑状态，则绑定操作事件
        if (this.$editable) {
            //工作区delegate绑定事件
            this.bindWorkAreaDelegate();
            //针对结点的一些集体delegate绑定事件
            this.bindNodeDelegate();
            //绑定结点/线的一些操作事件
            this.bindItemOperEvent();
            //创建结点遮罩层、标题文本框、折线移动框
            this.createGhost();
        }
    };

    //插件的定义    
    $.fn.goflow = function (opts) {
        return this.map(function () {
            var $this = $(this);

            if (opts == null
                && $this.data('goflow')) {
                return $this.data('goflow');
            }
            
            // 创建GoFlow实例
            var instance = new GoFlow();
            // 合并参数
            opts = $.extend({}, GoFlow.defaults, opts);
            // 初始化
            instance.init($this, opts);
            // 保存实例
            $this.data('goflow', instance);

            return instance.gfDiv()[0];
        });        
    };

})(jQuery); //闭包结束  